//Get the player's input
key_right = keyboard_check(vk_right);
key_left = -keyboard_check(vk_left);
key_jump = keyboard_check_pressed(vk_up);
key_turnleft = keyboard_check (vk_lshift);
key_turnright = -keyboard_check(vk_rshift);

//React to inputs and gravity
move = key_left + key_right;
hsp = move * movespeed;

// Rotation collision
rotate = key_turnleft + key_turnright;
image_angle += rotate * 5;

if (place_meeting(x,y,obj_wall))
{
	while (place_meeting(x,y,obj_wall))
    {
       image_angle -= rotate*0.1;
    }
}


if (vsp < 10) vsp += grav;

if (place_meeting(x,y+1,obj_wall))
{
    vsp = key_jump * -jumpspeed
}

// Horizontal collision
if (place_meeting(x+hsp,y,obj_wall))
{
    while (!place_meeting(x+sign(hsp),y,obj_wall))
    {
        x+= sign(hsp);
    }
    hsp = 0;
}
x += hsp;


// Vertical collision
if (place_meeting(x,y+vsp,obj_wall))
{
    while (!place_meeting(x,y+sign(vsp),obj_wall))
    {
        y+= sign(vsp);
    }
    vsp = 0;
}
y += vsp;